import { VNode, FunctionalComponent, ComponentPublicInstance, ComponentOptionsWithObjectProps, ComponentOptionsWithArrayProps, ComponentOptionsWithoutProps, ExtractPropTypes, Component, WritableComputedOptions, ComponentPropsOptions, VNodeProps, ComponentOptionsMixin } from 'vue';
import { GlobalMountOptions } from './types';
import { VueWrapper } from './vueWrapper';
declare type Slot = VNode | string | {
    render: Function;
} | Function;
declare type SlotDictionary = {
    [key: string]: Slot;
};
interface MountingOptions<Props, Data = {}> {
    data?: () => {} extends Data ? never : Data extends object ? Partial<Data> : never;
    props?: Props;
    attrs?: Record<string, unknown>;
    slots?: SlotDictionary & {
        default?: Slot;
    };
    global?: GlobalMountOptions;
    attachTo?: HTMLElement | string;
    shallow?: boolean;
}
export declare type ComputedOptions = Record<string, ((ctx?: any) => any) | WritableComputedOptions<any>>;
export declare type ObjectEmitsOptions = Record<string, ((...args: any[]) => any) | null>;
export declare type EmitsOptions = ObjectEmitsOptions | string[];
export declare function mount<TestedComponent extends FunctionalComponent<Props>, Props>(originalComponent: TestedComponent, options?: MountingOptions<Props>): VueWrapper<ComponentPublicInstance<Props>>;
export declare function mount<TestedComponent extends ComponentPublicInstance>(originalComponent: {
    new (): TestedComponent;
} & Component, options?: MountingOptions<TestedComponent['$props'], TestedComponent['$data']>): VueWrapper<TestedComponent>;
export declare function mount<Props = {}, RawBindings = {}, D = {}, C extends ComputedOptions = {}, M extends Record<string, Function> = {}, E extends EmitsOptions = Record<string, any>, Mixin extends ComponentOptionsMixin = ComponentOptionsMixin, Extends extends ComponentOptionsMixin = ComponentOptionsMixin, EE extends string = string>(componentOptions: ComponentOptionsWithoutProps<Props, RawBindings, D, C, M, E, Mixin, Extends, EE>, options?: MountingOptions<never, D>): VueWrapper<ComponentPublicInstance<Props, RawBindings, D, C, M, E, VNodeProps & Props>>;
export declare function mount<PropNames extends string, RawBindings, D, C extends ComputedOptions = {}, M extends Record<string, Function> = {}, E extends EmitsOptions = Record<string, any>, Mixin extends ComponentOptionsMixin = ComponentOptionsMixin, Extends extends ComponentOptionsMixin = ComponentOptionsMixin, EE extends string = string, Props extends Readonly<{
    [key in PropNames]?: any;
}> = Readonly<{
    [key in PropNames]?: any;
}>>(componentOptions: ComponentOptionsWithArrayProps<PropNames, RawBindings, D, C, M, E, Mixin, Extends, EE, Props>, options?: MountingOptions<Props, D>): VueWrapper<ComponentPublicInstance<Props, RawBindings, D, C, M, E>>;
export declare function mount<PropsOptions extends Readonly<ComponentPropsOptions>, RawBindings, D, C extends ComputedOptions = {}, M extends Record<string, Function> = {}, E extends EmitsOptions = Record<string, any>, Mixin extends ComponentOptionsMixin = ComponentOptionsMixin, Extends extends ComponentOptionsMixin = ComponentOptionsMixin, EE extends string = string>(componentOptions: ComponentOptionsWithObjectProps<PropsOptions, RawBindings, D, C, M, E, Mixin, Extends, EE>, options?: MountingOptions<ExtractPropTypes<PropsOptions>, D>): VueWrapper<ComponentPublicInstance<ExtractPropTypes<PropsOptions>, RawBindings, D, C, M, E, VNodeProps & ExtractPropTypes<PropsOptions, false>>>;
export declare const shallowMount: typeof mount;
export {};
